/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-concert-msgs-0.6.9-0precise-20150327-1850/srv/ClientList.srv
 *
 */


#ifndef CONCERT_MSGS_MESSAGE_CLIENTLISTRESPONSE_H
#define CONCERT_MSGS_MESSAGE_CLIENTLISTRESPONSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <concert_msgs/ConcertClient.h>

namespace concert_msgs
{
template <class ContainerAllocator>
struct ClientListResponse_
{
  typedef ClientListResponse_<ContainerAllocator> Type;

  ClientListResponse_()
    : clients()  {
    }
  ClientListResponse_(const ContainerAllocator& _alloc)
    : clients(_alloc)  {
    }



   typedef std::vector< ::concert_msgs::ConcertClient_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::concert_msgs::ConcertClient_<ContainerAllocator> >::other >  _clients_type;
  _clients_type clients;




  typedef boost::shared_ptr< ::concert_msgs::ClientListResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::concert_msgs::ClientListResponse_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct ClientListResponse_

typedef ::concert_msgs::ClientListResponse_<std::allocator<void> > ClientListResponse;

typedef boost::shared_ptr< ::concert_msgs::ClientListResponse > ClientListResponsePtr;
typedef boost::shared_ptr< ::concert_msgs::ClientListResponse const> ClientListResponseConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::concert_msgs::ClientListResponse_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::concert_msgs::ClientListResponse_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace concert_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'rocon_app_manager_msgs': ['/opt/ros/hydro/share/rocon_app_manager_msgs/cmake/../msg'], 'concert_msgs': ['/tmp/buildd/ros-hydro-concert-msgs-0.6.9-0precise-20150327-1850/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::concert_msgs::ClientListResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::concert_msgs::ClientListResponse_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::concert_msgs::ClientListResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::concert_msgs::ClientListResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::concert_msgs::ClientListResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::concert_msgs::ClientListResponse_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::concert_msgs::ClientListResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "9572afe4f30b1567d33f03cf448620a8";
  }

  static const char* value(const ::concert_msgs::ClientListResponse_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x9572afe4f30b1567ULL;
  static const uint64_t static_value2 = 0xd33f03cf448620a8ULL;
};

template<class ContainerAllocator>
struct DataType< ::concert_msgs::ClientListResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "concert_msgs/ClientListResponse";
  }

  static const char* value(const ::concert_msgs::ClientListResponse_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::concert_msgs::ClientListResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ConcertClient[] clients\n\
\n\
\n\
================================================================================\n\
MSG: concert_msgs/ConcertClient\n\
# \n\
# Describes a concert client - used only on the concert side\n\
#\n\
# Unique names - human consumable rocon name as well as global gateway name\n\
string name\n\
string gateway_name\n\
\n\
# The platform id triple (refer to concert_clients/PlatformInfo.msg for string values)\n\
string platform\n\
string system\n\
string robot\n\
\n\
# Current status of the concert client (refer to concert_msgs/ConcertClient.msg for mode strings)\n\
string client_status\n\
string app_status\n\
\n\
# Depracate this\n\
string status\n\
\n\
# Statistics\n\
time last_connection_timestamp\n\
\n\
rocon_app_manager_msgs/App[] apps\n\
\n\
================================================================================\n\
MSG: rocon_app_manager_msgs/App\n\
# app name\n\
string name\n\
# user-friendly display name\n\
string display_name\n\
string description\n\
string platform\n\
string status\n\
\n\
# icon for showing the app\n\
Icon icon\n\
#  ordered list (by preference) of pairing clients to interact with this robot app.\n\
PairingClient[] pairing_clients\n\
================================================================================\n\
MSG: rocon_app_manager_msgs/Icon\n\
# Image data format.  \"jpeg\" or \"png\"\n\
string format\n\
\n\
# Image data.\n\
uint8[] data\n\
================================================================================\n\
MSG: rocon_app_manager_msgs/PairingClient\n\
# like \"android\" or \"web\" or \"linux\"\n\
string client_type\n\
\n\
# like \"intent = ros.android.teleop\" and \"accelerometer = true\", used to choose which ClientApp to use\n\
KeyValue[] manager_data\n\
\n\
# parameters which just get passed through to the client app.\n\
KeyValue[] app_data\n\
================================================================================\n\
MSG: rocon_app_manager_msgs/KeyValue\n\
string key\n\
string value\n\
";
  }

  static const char* value(const ::concert_msgs::ClientListResponse_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::concert_msgs::ClientListResponse_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.clients);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct ClientListResponse_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::concert_msgs::ClientListResponse_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::concert_msgs::ClientListResponse_<ContainerAllocator>& v)
  {
    s << indent << "clients[]" << std::endl;
    for (size_t i = 0; i < v.clients.size(); ++i)
    {
      s << indent << "  clients[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::concert_msgs::ConcertClient_<ContainerAllocator> >::stream(s, indent + "    ", v.clients[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // CONCERT_MSGS_MESSAGE_CLIENTLISTRESPONSE_H
