/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-concert-msgs-0.6.9-0precise-20150327-1850/msg/LinkEdge.msg
 *
 */


#ifndef CONCERT_MSGS_MESSAGE_LINKEDGE_H
#define CONCERT_MSGS_MESSAGE_LINKEDGE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace concert_msgs
{
template <class ContainerAllocator>
struct LinkEdge_
{
  typedef LinkEdge_<ContainerAllocator> Type;

  LinkEdge_()
    : start()
    , finish()
    , remap_from()
    , remap_to()  {
    }
  LinkEdge_(const ContainerAllocator& _alloc)
    : start(_alloc)
    , finish(_alloc)
    , remap_from(_alloc)
    , remap_to(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _start_type;
  _start_type start;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _finish_type;
  _finish_type finish;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _remap_from_type;
  _remap_from_type remap_from;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _remap_to_type;
  _remap_to_type remap_to;




  typedef boost::shared_ptr< ::concert_msgs::LinkEdge_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::concert_msgs::LinkEdge_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct LinkEdge_

typedef ::concert_msgs::LinkEdge_<std::allocator<void> > LinkEdge;

typedef boost::shared_ptr< ::concert_msgs::LinkEdge > LinkEdgePtr;
typedef boost::shared_ptr< ::concert_msgs::LinkEdge const> LinkEdgeConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::concert_msgs::LinkEdge_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::concert_msgs::LinkEdge_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace concert_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'rocon_app_manager_msgs': ['/opt/ros/hydro/share/rocon_app_manager_msgs/cmake/../msg'], 'concert_msgs': ['/tmp/buildd/ros-hydro-concert-msgs-0.6.9-0precise-20150327-1850/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::concert_msgs::LinkEdge_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::concert_msgs::LinkEdge_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::concert_msgs::LinkEdge_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::concert_msgs::LinkEdge_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::concert_msgs::LinkEdge_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::concert_msgs::LinkEdge_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::concert_msgs::LinkEdge_<ContainerAllocator> >
{
  static const char* value()
  {
    return "01f86ee3e51dd78d2e2153a94d6f3865";
  }

  static const char* value(const ::concert_msgs::LinkEdge_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x01f86ee3e51dd78dULL;
  static const uint64_t static_value2 = 0x2e2153a94d6f3865ULL;
};

template<class ContainerAllocator>
struct DataType< ::concert_msgs::LinkEdge_<ContainerAllocator> >
{
  static const char* value()
  {
    return "concert_msgs/LinkEdge";
  }

  static const char* value(const ::concert_msgs::LinkEdge_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::concert_msgs::LinkEdge_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# Edge of the implementation graph. Client-Topic, or \n\
# Topic-Client or Client-Action or Action-Client\n\
\n\
string start\n\
string finish\n\
string remap_from\n\
string remap_to\n\
";
  }

  static const char* value(const ::concert_msgs::LinkEdge_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::concert_msgs::LinkEdge_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.start);
      stream.next(m.finish);
      stream.next(m.remap_from);
      stream.next(m.remap_to);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct LinkEdge_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::concert_msgs::LinkEdge_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::concert_msgs::LinkEdge_<ContainerAllocator>& v)
  {
    s << indent << "start: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.start);
    s << indent << "finish: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.finish);
    s << indent << "remap_from: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.remap_from);
    s << indent << "remap_to: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.remap_to);
  }
};

} // namespace message_operations
} // namespace ros

#endif // CONCERT_MSGS_MESSAGE_LINKEDGE_H
