/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-concert-msgs-0.6.9-0precise-20150327-1850/msg/LinkNode.msg
 *
 */


#ifndef CONCERT_MSGS_MESSAGE_LINKNODE_H
#define CONCERT_MSGS_MESSAGE_LINKNODE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace concert_msgs
{
template <class ContainerAllocator>
struct LinkNode_
{
  typedef LinkNode_<ContainerAllocator> Type;

  LinkNode_()
    : id()
    , tuple()
    , min(0)
    , max(0)
    , force_name_matching(false)  {
    }
  LinkNode_(const ContainerAllocator& _alloc)
    : id(_alloc)
    , tuple(_alloc)
    , min(0)
    , max(0)
    , force_name_matching(false)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _id_type;
  _id_type id;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _tuple_type;
  _tuple_type tuple;

   typedef int8_t _min_type;
  _min_type min;

   typedef int8_t _max_type;
  _max_type max;

   typedef uint8_t _force_name_matching_type;
  _force_name_matching_type force_name_matching;


    enum { UNLIMITED_RESOURCE = -1 };
 

  typedef boost::shared_ptr< ::concert_msgs::LinkNode_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::concert_msgs::LinkNode_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct LinkNode_

typedef ::concert_msgs::LinkNode_<std::allocator<void> > LinkNode;

typedef boost::shared_ptr< ::concert_msgs::LinkNode > LinkNodePtr;
typedef boost::shared_ptr< ::concert_msgs::LinkNode const> LinkNodeConstPtr;

// constants requiring out of line definition

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::concert_msgs::LinkNode_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::concert_msgs::LinkNode_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace concert_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'rocon_app_manager_msgs': ['/opt/ros/hydro/share/rocon_app_manager_msgs/cmake/../msg'], 'concert_msgs': ['/tmp/buildd/ros-hydro-concert-msgs-0.6.9-0precise-20150327-1850/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::concert_msgs::LinkNode_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::concert_msgs::LinkNode_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::concert_msgs::LinkNode_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::concert_msgs::LinkNode_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::concert_msgs::LinkNode_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::concert_msgs::LinkNode_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::concert_msgs::LinkNode_<ContainerAllocator> >
{
  static const char* value()
  {
    return "8cb53e2248706eb448c74babbdffc381";
  }

  static const char* value(const ::concert_msgs::LinkNode_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x8cb53e2248706eb4ULL;
  static const uint64_t static_value2 = 0x48c74babbdffc381ULL;
};

template<class ContainerAllocator>
struct DataType< ::concert_msgs::LinkNode_<ContainerAllocator> >
{
  static const char* value()
  {
    return "concert_msgs/LinkNode";
  }

  static const char* value(const ::concert_msgs::LinkNode_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::concert_msgs::LinkNode_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# Representation of a concert client node in the implementation graph\n\
\n\
# unique identifier\n\
string id\n\
\n\
# tuple representing the client node - platform.system.robot.app, e.g. linux.ros.turtlebot.turtle_stroll\n\
string tuple\n\
\n\
# Constraints on how many of these nodes may exist\n\
#   min, max not set -> min = 1, max = 1\n\
#   min not set -> min = 1\n\
#   max not set -> max = UNLIMITED_RESOURCE\n\
# Zero is a valid minimum value\n\
int8 UNLIMITED_RESOURCE=-1\n\
int8 min\n\
int8 max\n\
\n\
# Force matching of robot name (only really useful for demos)\n\
bool force_name_matching\n\
";
  }

  static const char* value(const ::concert_msgs::LinkNode_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::concert_msgs::LinkNode_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.id);
      stream.next(m.tuple);
      stream.next(m.min);
      stream.next(m.max);
      stream.next(m.force_name_matching);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct LinkNode_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::concert_msgs::LinkNode_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::concert_msgs::LinkNode_<ContainerAllocator>& v)
  {
    s << indent << "id: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.id);
    s << indent << "tuple: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.tuple);
    s << indent << "min: ";
    Printer<int8_t>::stream(s, indent + "  ", v.min);
    s << indent << "max: ";
    Printer<int8_t>::stream(s, indent + "  ", v.max);
    s << indent << "force_name_matching: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.force_name_matching);
  }
};

} // namespace message_operations
} // namespace ros

#endif // CONCERT_MSGS_MESSAGE_LINKNODE_H
